/**
 * 广告模块配置
 */
DGC.Ads = {

    /**
     * 页面配置
     */
    PAGES :{
        /**
         * 用户成就
         */
        UserAchieve: {
            LEFT: "4f5da34cef7759f964000000", //成就左
           RIGHT: "4f5da36bef77595464000000" //成就右
        },
        /**
         * 排行榜
         */
        BoardCategory:{
            LEFT: "4f5da385ef77590664000000", //SDK排行模式左
           RIGHT: "4f5da39aef77590664000001" //SDK排行模式右
        },
        /**
         * 排行榜
         */
        Dashboard:{
             LEFT: "4f5da3d5ef77590165000000", //SDK排行模式左
            RIGHT: "4f5da3e7ef7759f764000000" //SDK排行模式右
        },
        /**
         * 本地游戏
         */
        LocalGames:{
            BANNERS: "4f5da3f8ef77590265000000" //SDK游戏
        },

        /*
         * 玩过的游戏
         */
        PlayedGames:{
            BANNERS: "4f5da472ef77595865000000" //SDK我/玩家
        }
    },

    /**
     * 根据权重获取banner要展示的广告
     * @param {Json} params bannerAds 要显示的广告列表
     */
    getBannerShowAd:function(bannerAds){
        var r = Math.floor(Math.random()*100+1);//产生1-100之间的随机数
        var offset = 0;
        for (var i=0; i < bannerAds.length; i++) {
              var bannerAd = bannerAds[i];
              offset += bannerAd.percentage;
            if(r <= offset){
                return bannerAd;
            }
        }
        return bannerAds[0];
    },


    /**
     * 获取页面指定广告位ID
     * @param {Stirng} viewName 视图名称
     */
    getBanners: function(viewName){
        var viewBanners = DGC.Ads.PAGES[viewName],
            keys = [];
        for(var key in viewBanners){
            keys.push(viewBanners[key]);
        }
        return  keys;
    },

    /**
     * 获得左右区块HTML模板
     */
    getSidesAdTpl : function(){
        return '<div class="common-banner-ad hbox-layout" style="display:none;">\
                    <div class="box-flex-1"></div>\
                    <div class="ad-wrap" data-key="<*=this.leftAd.bid*>">\
                        <a href="#">\
                             <img src="<*=this.leftAd.img_url*>"></img>\
                        </a>\
                    </div>\
                    <div class="box-flex-1"></div>\
                    <div class="ad-wrap" data-key="<*=this.rightAd.bid*>">\
                        <a href="#">\
                            <img src="<*=this.rightAd.img_url*>"></img>\
                        </a>\
                    </div>\
                    <div class="box-flex-1"></div>\
                </div>'
    },

    /**
     * 获取滚动的模板
     */
    getScrollAdTpl : function(){
        return '<div class="common-ad-wrap"  style="display:none;">\
                    <div class="common-statebar">{0}</div>\
                    <div class="scroll-banner-ad hbox-layout box-pack-center">\
                        <div class="box-flex-1 ad-wrap" data-bid="{1}">\
                            <div class="ad-content"></div>\
                            <div class="ad-nav hbox-layout box-align-center box-pack-end">\
                                <div class="ad-nav-items hbox-layout box-align-center"></div>\
                            </div>\
                            <div class="ad-title"></div>\
                        </div>\
                    </div>\
                </div>'
    },

    /**
     * 滚动内容模板
     */
    getScrollAdCTpl:function(){
        return '<div class="ad-item" data-key="{0}" data-name="{1}" style="display:none;"><img src="{2}"></img></div>';
    },

    /**
     * 滚动导航模板
     */
    getScrollAdNTpl:function(){
        return '<div class="ad-nav-item" data-key="{0}"></div>';
    }

}
