/**
 * 游戏模块数据模型
 */
DGC.Model.Game = $.inherits(DGC.Model,{

    id : 'model_games',

    constructor : function(config){

        //声明自定义事件
        this.defineEvents(
            'localgame' //查询游戏的排行列表
        );

        //API接口声明
        this.apiURL = {
            GET_LOCAL_GAME:{
                url : "/games/more?channel_id={0}",
                pattern : /\/games\/more\?channel_id=.*/
            }
        }

        DGC.Model.Game.superclass.constructor.call(this,config);
    },

    /**
     * 初始化监听数据流
     */
    registryMessages : function(){
       var MSG  = DGC.Service.Messages;
       this.service.on(MSG.QUERY_LOCAL_GAME, this.queryLocalGameListCallback, this);
       this.service.on(MSG.QUERY_LOCAL_GAME_STATE, this.queryLocalGameListStateCallback, this);
    },

    //查询所有游戏
    queryLocalGameList: function(){
        var DAU = DGC.ActionUtil, MSG = DGC.Service.Messages,API = this.apiURL;
        var requestBody  = {
                msgID : MSG.QUERY_LOCAL_GAME,
                params: {
                    "GET": [
                        {
                            url: $.format(API.GET_LOCAL_GAME.url,[ window.sdk.channel_id ]) //AD0S0N00000
                        }
                    ]
                }
            };

        //Web Debug
        if(DEBUG.isWebModel()){
            $.extend(requestBody, {
                version: '1.2.0',
                mockUrl: 'game/gamelist.json'
            });
        }

        //如果有Cache，直接触发
        var cacheItem = this.getCacheByObj(requestBody);
        if(cacheItem){
            this.fire("localgame",cacheItem);
        }else{
            DAU.requestAPI(requestBody);
        }
    },

    queryLocalGameListCallback : function(msg){
        var result = this.processResponse(msg), API = this.apiURL;

        if(result && result.success){
            var GET_RESPONSE = this.getQueryReponse(result);
            for(var url in GET_RESPONSE){
                if(API.GET_LOCAL_GAME.pattern.test(url)){
                    this.putCacheByObj(this.getRequestKey(msg), GET_RESPONSE[url].data);
                    this.fire("localgame", GET_RESPONSE[url].data);
                }
            }
        }
    },

    queryLocalGameListStateCallback : function(msg){
        this.fire("localgamestate", msg);
    }

});
