/**
 * 排行榜业务模块
 */
DGC.Module.HighScores = $.inherits(DGC.Module, {

    /**
     * 排行榜
     * @type String
     */
    baseId : 'highScoreTab',

    /**
     * 默认加载视图
     * @type String
     */
    deafultView: 'Dashboard',

    /**
     * 判断是否为根页面
     */
    isRootPage: function(){
        //本用户/本游戏
        var cView = this.currentView;

        //在线模式
        if(!window.sdk.isOffline){
            //位于排行榜模式或排行榜列表
            if(cView.name == 'Dashboard' || cView.name == 'BoardCategory'){
                if(cView.game.id == window.sdk.game.id && cView.player.id == window.sdk.player.id && !this.hasHistoryView()){
                    return true;
                }
            }
        //离线模式
        }else{
            if(cView.name == 'OfflineBoard' && cView.boardList.length <= 1 ){
                return true;
            }else if(cView.name == 'BoardCategory'){
                return true;
            }
        }

        return false;
    },

    onInitialize : function(){

       //判断为是否为离线模式,并设置默认视图
       this.deafultView = window.sdk.isOffline ? "OfflineBoard" : "Dashboard";

       //订阅自定义事件
       this.autoRegsiterEvents(DGC.Module.HighScores.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Me.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Achievement.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Payment.EventProxy);
       this.autoRegsiterEvents(DGC.Module.PromotionBanner.EventProxy);
    },

    //销毁时调用
    onDestory : function(){
        /*
        this.model['hs'].un('frquery',    this.showFriendRank, this);
        this.model['hs'].un('worldquery', this.showAllRank, this );
        this.model['hs'].un('areaquery',  this.showAreaRank , this);
        */
    },

    showFriendRank : function(ranklist){
        //导航切换
        /*
        DGC.Application.navigateTo('moudleName','viewName');
        this.action.loadView('11111');
        //切换显示当前好友排行
        if(this.currentView instanceof  === 'xxx'){
            this.currentView.renderFriendRank();
        }
        */
    },

    /**
     * 显示
     */
    showBoardList : function(list, defaultView){
        if(this.isViewShow(defaultView)){
             this.currentView.renderBoardList(list);
        }
    }

});


/**
 * 事件代理转发对象
 */
DGC.Module.HighScores.EventProxy = {
    "hs":{
        "leaderboards":[{
            viewName : "Dashboard", //在指定视图时触发
            fnName : "findDefaultBoard" //调用当前视图的渲染方法
        },{
            viewName : "OfflineBoard",
            fnName : "findDefaultBoard"
        },{
            viewName : "BoardCategory",
            fnName: "renderBoardList"
        }],
        "offlinerank":[
            {
                viewName : "OfflineBoard",
                fnName: "renderRankList"
            },
            {
                viewName: "Dashboard",
                fnName: "renderLocalRank"
            }
        ],
        "friendrank":{
            viewName: "Dashboard",
            fnName: "renderFriendRank"
        },
        "arearank":{
            viewName: "Dashboard",
            fnName: "renderAreaRank"
        },
        "worldrank":{
            viewName: "Dashboard",
            fnName: "renderWorldRank"
        },
        //跳转到PLAYER详细
        "playerdetail":{
            viewName: "FriendsDetail",
            fnName: "renderPlayerDetail"
        }
    }
}

