/**
 * "我"信息业务模型
 */
DGC.Module.Me = $.inherits(DGC.Module, {

    baseId : 'meTab',

    /**
     * 默认加载视图
     * @type String
     */
    deafultView: 'MyDetail',

    /**
     * 判断是否为根页面
     */
    isRootPage: function(){
        return (!this.hasHistoryView()
            && this.currentView.name == this.deafultView
            && this.currentView.game.id == window.sdk.game.id );
    },

    onInitialize : function(){
       //订阅model中的自定义事件
       this.autoRegsiterEvents(DGC.Module.Me.EventProxy);
       this.autoRegsiterEvents(DGC.Module.HighScores.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Achievement.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Payment.EventProxy);
       this.autoRegsiterEvents(DGC.Module.Game.EventProxy);
       this.autoRegsiterEvents(DGC.Module.PromotionBanner.EventProxy);
    }

});

/**
 * 事件代理转发对象
 */
DGC.Module.Me.EventProxy = {
    "me":{
        "mydetail":{
            viewName: "MyDetail",
            fnName: "showMyGameInfo"
        },
        "playedgame": {
            viewName : "PlayedGames", //在指定视图时触发
            fnName : "renderPlayedGames" //调用当前视图的渲染方法
        },
        "playerfriends": [
            {
                viewName : "MyFriends",
                fnName : "renderMyFriends"
            },
            {
                viewName: "FriendsToFriends",
                fnName : "renderFriends"
            }
        ],
        "playerfollows": {
            viewName: "MyFriends",
            fnName: "renderMyFans"
        },
        "playerdetail":{
            viewName: "FriendsDetail",
            fnName: "renderPlayerDetail"
        },
        "playerrecord":{
            viewName: "GameInfo",
            fnName: "renderRecordInfo"
        },
        "searchfriends":{
            viewName: "InviteFriends",
            fnName: "renderMatchedPlayers"
        },
        "updatefriendsship":[{
            viewName: "FriendsDetail",
            fnName: "updateFriendsship"
        },{
            viewName: "InviteFriends",
            fnName: "updateFriendsship"
        }],
        "bindsinasuccess":[{
            viewName: "Setting",
            fnName: "bindSinaProxy"
        },{
            viewName: "BindSina",
            fnName: "bindSinaProxy"
        }],
        "unbindsinasuccess":{
            viewName: "Setting",
            fnName: "updateSinaBind"
        },
        "sycsina":[{
            viewName: "Setting",
            fnName: "sycSinaProxy"
        },{
            viewName: "BindSina",
            fnName: "sycSinaProxy"
        }],
        "bindrenrensuccess":{
            viewName: "Setting",
            fnName: "bindRenRenProxy"
        },
        "unbindrenrensuccess":{
            viewName: "Setting",
            fnName: "updateRenrenBind"
        },
        "sycrenren":{
            viewName: "Setting",
            fnName: "sycRenRenProxy"
        },
        "sendsinaachieve":{
            viewName: "Setting",
            fnName: "updateSinaAchieveStatus"
        },
        "sendrenrenachieve":{
            viewName:"Setting",
            fnName:"updateRenRenAchieveStatus"
        },
        "tipsready":{
            viewName: "MyDetail",
            fnName: "updateMyNewFriends"
        },
        "updatemydetail":[{
            viewName: "MyDetail",
            fnName: "updatePlayerDetail"
        },{
            viewName:"Setting",
            fnName: "updatePlayerDetail"
        }],
        'updateloginplayer':{
            viewName: "MyDetail",
            fnName: "updatePlayerInfo"
        },

        //SDK1.2
        'selectavatarway':[{
            viewName: "Setting",
            fnName: "avatarWaySelected"
        },{
            viewName: "MyDetail",
            fnName: "avatarWaySelected"
        }],
        'updateavatar':[{
            viewName: "Setting",
            fnName: "updatePlayerAvatar"
        },{
            viewName: "MyDetail",
            fnName: "updatePlayerDetail"
        } ],
        'updatenickname':{
            viewName: "Setting",
            fnName: "updatePlayerName"
        },
        'updategender':{
            viewName: "Setting",
            fnName: "updatePlayerGender"
        },
        'feedback': {
            viewName: "AboutUs",
            fnName: "feedBackProxy"
        },
        'clearaccountsuccess':{
            viewName: "Setting",
            fnName: "useNewAccount"

        },
    	"latestactivity": {
            viewName: "Activity",
            fnName: "renderLatestActivity"
        },
        "circuseeactivity": {
            viewName: "Activity",
            fnName: "renderCircuseeActivity"
        },
        "updatecircuseeactivity":{
            viewName: "Activity",
            fnName: "updateCircuseeActivity"
        },
        "handlePromoteCode":{
            viewName: "PromoteCode",
            fnName: "handlePromoteCode"
        },
        "localgamestate":{
            viewName: "PromoteCode",
            fnName: "showGameStatus"
        },
        "snssharecontent":[{
            viewName: "AboutUs",
            fnName: "contentReadyProxy"
        },{
            viewName: "Dashboard",
            fnName: "contentReadyProxy"
        },{
            viewName: "MyFriends",
            fnName: "contentReadyProxy"
        }],
        "snssharesuccess":[{
            viewName:"AboutUs",
            fnName: "sendSNSSuccessProxy"
        },{
            viewName: "Dashboard",
            fnName: "sendSNSSuccessProxy"
        },{
            viewName: "MyFriends",
            fnName: "sendSNSSuccessProxy"
        }]

    }
}
