/**
 * 绑定新浪微博
 */
DGC.View.BindSina =  $.inherits(DGC.View, {

    baseId: 'mebind-sina',

    title: 'A_TITLE_BIND_SINA',

    renderTpl:'1.2.0/js/template/bindsina.html',

    /**
     * 发送weibo信息
     */
    message: "",

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        var ATTR = DH.ATTR;

        DGC.ActionUtil.fullScreen(true);
        DGC.ActionUtil.transparentBG();

        var params  = {
            meModel : this.action.model['me'] ,
            maskTransparent: true,
            //关闭窗口回调
            cancelCallBack : function(){
                //手动关闭窗口回退游戏界面
                DGC.ActionUtil.returnToGame();
            }
        };

        //未绑定
        if(!DH.isSNSBound(ATTR.BIND_KEY.SINA)){
            $.extend(params, {
                bindSuccess : $.bindFn(this.sendSinaMsg, this) //绑定成功后执行
            });
        //过期重绑定
        }else if(DH.isSNSBound(ATTR.BIND_KEY.SINA) && DH.isSNSExpried(ATTR.BIND_KEY.SINA)){
            $.extend(params, {
                relogin: true,
                reloginSuccess : $.bindFn(this.sendSinaMsg, this) //重验证后成功后执行
            });
        }

        this.action.showDialog(
            "SinaDialog",
            params,
            function(name, params){
                //弹出绑定的Dialog
                this.sina = new DGC.Dialog[name](params);
                this.sina.show();
            },
            this);
    },

    /**
     * 绑定新浪窗口代理
     */
    bindSinaProxy: function(data){
        if(this.sina){
            this.sina.loginSuccess(data);
        }
    },

    /**
     * 同步新浪信息代理
     */
    sycSinaProxy : function(result){
        if(this.sina){
            this.sina.sycPlayerSuccess(result);
        }
    },

    /**
     * 发送新浪微博
     */
    sendSinaMsg: function(){
        this.action.model['me'].sendSinaweibo(this.message, true);
    },

    onDestory: function(){
        //释放窗口引用
        if(this.sina){
            this.sina.destory();
        }
        this.sina = null;
    }

});