/**
 * 充值模式选择
 */
DGC.View.ChargeAccount =  $.inherits(DGC.View, {

    baseId: 'charge-account-view',

    renderTpl:'1.2.0/js/template/chargeaccount.html',

    paymentWays: undefined,

    /**
     * 支付道具信息(仅支付时需要)
     */
    orderInfo: undefined,

    /**
     * 入口模式
     * 0:充值入口
     * 1:游戏开发者入口
     * 2:道具商城入口
     */
    chargeModel: 0,

    /**
     * 是否只有一种支付方式
     */
    onlyPay: false,

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        this.viewTpl = {
            CHARGEWAY: "#chargeway-tpl",
            LEDOU_REMAIN:"#account-remain-tpl",
            RECENT_CHARGE:"#recent-charge-tpl",
            ITEM_CHARGE:"#item-detail-tpl",
            ITEM_HISTORY: '#item-history-tpl',
            ITEM_HISTORY_ICON: '#item-history-icon-tpl',
            ITEM_CONTENT: '#item-history-content-tpl'
        }

        switch(this.chargeModel){
            case 0/*充值 */:
                this.setTitle(resName.A_TITLE_CHARGE_ACCOUNT);
                this.action.model['pay'].queryChargeList(0/*充值*/);
                //查询用户余额和最后一次交易记录(不支付乐币，不查询交易记录)
                if(window.sdk.channel.enable_coin_payment){
                    this.action.model['pay'].queryPlayerCoins(true, true);
                    $("#charge-account").addClass('coins-charge-history'); //充值列表
                }
                //SKYNET_PAGE_ME_PAYMENT

                //记录页面访问次数
                DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_PAYMENT);
                break;
            case 1/*游戏开发者*/:
                /*游戏入口则默认视图*/
                //this.setBackEnable(false);
                //this.setTitle(resName.A_TITLE_PAY_ACCOUNT);
                //查询购买道具信息
                //this.action.model['pay'].queryBuyItemDetail();
                //this.action.model['pay'].queryChargeList(1/*支付*/);
                //break;
            case 2/*道具商城*/:
                this.setTitle(resName.A_TITLE_PAY_ACCOUNT);
                this.action.model['pay'].queryChargeList(1/*支付*/);
                $("#charge-account").addClass('buy-item-list'); //表示支付列表

                //购买道具栏信息(当前只支持一个道具)
                this.el.prepend(this.renderByTpl(this.viewTpl.ITEM_CHARGE, {
                    productName: this.orderInfo.item.product.name,
                    needPayCoins: DGC.Common.currencyFormat( this.orderInfo.quantity * this.orderInfo.item.product.price, 2),
                    hasCoins: window.sdk.player.coins,
                    icon: this.orderInfo.item.product.icon
                }));

                //记录页面访问次数
                DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_MALL_PURCHASE);
                break;
        }
    },

    /**
     * 渲染当前用户信息
     * @param {Number} coins 余额
     * @param {Arrary} history 最近支付记录()
     */
    renderPlayerCoins: function(coins, history){
        var listDom = $("#charge-account"),
            DC = DGC.Common;

        window.sdk.player.coins = coins;

        //显示余额
        var remainEl = $(this.renderByTpl(this.viewTpl.LEDOU_REMAIN,{coins: window.sdk.player.coins}));
        //查看交易记录
        remainEl.find(".charge-history")
            .bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')})
            .bind("tap", { context: this } , function(event){
                //“充值”界面，点击 “查询交易纪录”
                DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_ME_PAYMENT_LIST,
                    {
                        'user_id':window.sdk.player.id
                    }
                );
                var context = event.data.context;
                context.action.setView("ChargeHistory");
        });

        listDom.before(remainEl);

        //显示最近充值记录
        if(history.length > 0){
            var record = history[0];
            $.extend(record,{
                detailHtml: this.getHistoryHtml(record),
                time: DC.getFormatDate(DC.getDateFromTime(record.datetime), true )
            })

            listDom.after(this.renderByTpl(this.viewTpl.RECENT_CHARGE, record));

            //延迟加载最近买道具记录图标
            switch(record.type){
                case 0 /*乐币买道具*/:
                case 2 /*RMB买道具*/:
                case 4 /*兑换码兑换道具*/:
                case 6 /*积分买道具*/:
                    if(!$.isEmpty(record.product_icon)){
                        this.loadImages({ url: record.product_icon },function(img, data){
                            var imgWrap  = $(".foot-bar .content .icon");
                            imgWrap.find(".default-icon").replaceWith("<img src='" + img.src +"'><div class='mask'></div>");
                        });
                    }
                    break;
                default:
                    break;
            }
        }
    },

    /**
     * 历史记录结构
     */
    getHistoryHtml: function(record){
        var html = '';
        switch(record.type){
             case 0 /*乐币买道具*/:
                 html = this.renderByTpl(this.viewTpl.ITEM_HISTORY_ICON, {
                     pName: record.product_name,
                     label: resName.TEXT_CHARGEHISTORY_BUY ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY
                 });
                break;
            case 1 /*充值乐币*/:
                html = this.renderByTpl(this.viewTpl.ITEM_HISTORY, {
                     label: resName.TEXT_CHARGEHISTORY_CHARGE ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY_RMB
                });
                break;
            case 2 /*RMB买道具*/:
                html = this.renderByTpl(this.viewTpl.ITEM_HISTORY_ICON, {
                     pName: record.product_name,
                     label: resName.TEXT_CHARGEHISTORY_BUY ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY_RMB
                 });
                break;
            case 4 /*兑换码兑换道具*/:
                 html = this.renderByTpl(this.viewTpl.ITEM_CONTENT, {
                     pName: record.product_name,
                     label: resName.TEXT_CHARGEHISTORY_EX_ITEM
                 });
                break;
            case 5 /*兑换码兑换乐币*/:
                html = this.renderByTpl(this.viewTpl.ITEM_HISTORY, {
                     label: resName.TEXT_CHARGEHISTORY_EXCHANGE ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY
                });
                break;
            case 6 /*积分买道具*/:
                 html = this.renderByTpl(this.viewTpl.ITEM_HISTORY_ICON, {
                     pName: record.product_name,
                     label: resName.TEXT_CHARGEHISTORY_USE ,
                     number: record.amount,
                     unit: resName.TEXT_LEDOUSHOP_CURRENCY_INTEGRAL
                });
                break;
        }

        return html;
    },


    /**
     * 支付列表动态渲染
     */
    renderChargeList : function(chargelist){
        //仅一种支付方式,直接进入相关模式
        if(chargelist.length  == 1 /*只支持一种支付模式*/){

           this.onlyPay = true; /*只有一种支付方式*/

            //充值模式
           if(this.chargeModel == 0 /*充值*/){

               //具体充值方式页面
               this.action.setView('ChargeCommit',{
                   payWay: chargelist[0],
                   onlyPay: this.onlyPay
               });
           //支付模式
           }else{
               this.callDetaiPayMethod(chargelist[0]);
           }
        //多种支付方式
        }else{
            var key = "";
            //判断充值还是支付模式
            switch(this.chargeModel){
                case 0 /*充值*/:
                    key = "chargeway";
                    break;
                case 1:
                case 2:/*支付*/
                    key = "payway";
                    break;
            }

            //键值
            var identifier = window.sdk.config_params[DGC.Common.localKey(key)];

            //最近记录键值
            if(identifier){
                for (var i = 0; i  < chargelist.length; i ++) {
                    var charge = chargelist[i];
                    if(charge.identifier == identifier){
                        chargelist.splice( i , 1); //先移除匹配的支付方式
                        chargelist = [charge].concat(chargelist); //重新生成支付方式列表
                        break;
                    }
                };
            }

            var items = $(this.renderByTpl(this.viewTpl.CHARGEWAY, chargelist));

            items.bind(DGC.Common.E_TAP_DOWN, DGC.Common.listTapDownHandler)
                .bind(DGC.Common.E_TAP_UP,DGC.Common.listTapEndHandler)
                .bind('tap', { context: this }, this.showChargeWayDetai);

            this.el.find('.chargeway-list').append(items);
            $("#charge-account").show();

            this.loadImages( this.getDelayIcons(chargelist) ,function(img, data){
                var imgWrap  = $(".list-item[data-key='"+ data.identifier +"']");
                imgWrap.find(".default-icon").replaceWith("<img src='"+ img.src + "'></img>");
            });

            //缓存支付列表
            this.paymentWays = chargelist;
        }

    },

    /**
     * 获取需要延迟加载的图标信息
     */
    getDelayIcons : function(charges){
        var delays = [];

        //delayIcons
        for (var i = 0; i < charges.length; i++) {
            var charge = charges[i];
            if(!$.isEmpty(charge.icon)){
                delays.push({
                    url: charge.icon,
                    identifier: charge.identifier
                });
            }
        };

        return delays;
    },

    /**
     * 切换至具体支付页面
     */
    showChargeWayDetai: function(event){
       var context = event.data.context,
           key = $(this).attr("data-key"),
           paymentWay;

       //查找当前点击支付方式
       for (var i = 0; i < context.paymentWays.length; i++) {
           paymentWay = context.paymentWays[i];
           if(paymentWay.identifier == key){
              break;
           }
       };

       var obj = {};
       //充值模式
       if(context.chargeModel == 0 /*充值*/){

           //充值乐币”界面，点击具体的支付方式
           DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_ME_PAYMENT_CHARGE_ACTION,
                {
                    'user_id': window.sdk.player.id,
                    'charge_channel': DGC.Event.Util.getPayEvent(paymentWay.identifier)
                }
           );

           //记录最近充值方式
           obj[DGC.Common.localKey('chargeway')] = paymentWay.identifier;
           //具体充值方式页面
           context.action.setView('ChargeCommit',{
               payWay: paymentWay
           });
       //支付模式
       }else{

           //“支付道具”界面，点击具体某一个支付渠道
           DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_MALL_PURCHASE_CHANNEL_ACTION,
                {
                    'user_id': window.sdk.player.id,
                    'game_id': window.sdk.game.id,
                    'product_id': context.orderInfo.item.product.id,
                    'purchase_channel': DGC.Event.Util.getPayEvent(paymentWay.identifier)
                }
           );

          //记录最近支付方式
          obj[DGC.Common.localKey('payway')] = paymentWay.identifier;

          context.callDetaiPayMethod(paymentWay);
       }

       DGC.ActionUtil.setConfigParams(obj);
    },


    /**
     * 根据支付方式不同，跳转至不同界面
     */
    callDetaiPayMethod: function(payMethod){

        //易宝  进入卡号/密码界面
        var chargeMoney  = DGC.Common.currencyFormat(this.orderInfo.quantity * this.orderInfo.item.product.price * payMethod.rate * payMethod.discount , 2);

        //支付宝/GFan/短代直接进入支付界面
        switch(payMethod.identifier){
             /*易宝移动，联通，电信*/
             case 3:
             case 4:
             case 5:
                 /*易宝支付页面*/
                 this.action.setView("PayCommit",{
                     payWay: payMethod,
                     orderInfo: this.orderInfo,
                     onlyPay: this.onlyPay
                 });
                 break;
             /*支付宝*/
             case 6:
                 this.action.model['pay'].payOrderByFeed(payMethod.identifier,{
                     quantity: this.orderInfo.quantity,
                     product_id: this.orderInfo.item.product.id,
                     recharge: chargeMoney
                }, this.orderInfo.item);
                break;
             case 7  /*电信短代*/:
             case 9  /*移动短代*/:
             case 11 /*索爱*/:
             case 12 /*魅族*/:
             case 13 /*瓦尔雷斯*/:
             case 15 /*华为*/:
             case 20 /*Gfan*/:
             case 21 /*盛付通*/:
                 this.action.model['pay'].payOrderByLocal(payMethod.identifier,{
                     quantity: this.orderInfo.quantity,
                     item: this.orderInfo.item ,
                     money: chargeMoney
                 });
                 break;
        }
    },

    /**
     * 支付宝支付结果回调
     * @param {Boolean} result 充值结果
     * @param {object} detail 支付方式以及提示
     * @param {Object} failitem 支付失败的item对象
     */
    payByAliResult: function(result, detail , failitem){
        var DAU = DGC.ActionUtil;

        if(detail.paymethod == 6 /*支付宝*/){
            //支付宝页面跳转
            if(result){
                //支付宝下单成功->打开新页面
                DAU.openWebView(detail.payment_url, true);
                DAU.notifySDKBuyResult(3 /*支付宝/易宝*/, result, detail);
            }else{
                //显示支付提示信息
                this.action.model['pay'].showPayErrorDetail(detail);
                //通知SDK支付操作失败
                DAU.notifySDKBuyResult(3 /*支付宝/易宝*/, result, failitem , detail.err_code);
            }
        }
    },

    /**
     * 本地支付后结果回调(短代,机锋)
     */
    payByLocalResult: function(result, detail){
        //跳转显示充值结果
        this.action.setView("PayResult",{
            result: result,
            payInfo: detail
        }, false/*非重置*/, this.onlyPay /*不保存当前视图*/);
    }

});