/**
 * 充值历史记录
 */
DGC.View.ChargeHistory =  $.inherits(DGC.View, {

    baseId: 'chargehistroy-view',

    title: 'A_TITLE_CHARGE_HISTORY',

    renderTpl:'1.2.0/js/template/chargehistory.html',

    cachedHistroy: undefined,

    /**
     * 当前展开的充值项项
     */
    expandDetail: undefined,

    historyCur: undefined,

    loadMoreTask: 0,

    viewReady: function(){

        this.viewTpl = {
            CHARGE : "#history-tpl",
            DETAIL_FIELD:"#detail-tpl"
        }

        //历史记录
        this.cachedHistroy = [];

        //监听scroll实现动态加载
        $(window).bind("scroll", { context : this } , this.scrollLoadMore);

        //默认加载25条
        this.action.model['pay'].queryChargeHistory(25);

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_PAYMENT_HISTORY);
    },

    /**
     * 渲染充值列表
     */
    renderChargeList: function(result , isMore ){
        var wrap = this.el.find(".charge-list"),
            exists = this.el.find(".charge-list .list-item").size(),
            charges = result.data, //充值列表
            DC = DGC.Common;

        //显示最近共有X条充值记录
        $("#ch-title").text($.format(resName.TEXT_CHARGEHISTORY_TITLE ,[ exists + charges.length]));

        //无充值/购买历史
        if(charges.length == 0 && !isMore){
            wrap.html(DGC.Common.getEmptyListItemHtml(resName.TEXT_CHARGEHISTORY_CHARGE_NONE));
            return false;
        }

        //存在数据
        if(charges.length > 0){

            //上次渲染Index
            window.sdk.historyIndex = exists ;

            //缓存数据
            this.cachedHistroy = this.cachedHistroy.concat(charges);

            for (var i = 0 ; i < charges.length; i++) {
                var charge = charges[i];
                $.extend(charge,{
                    title : this.getTitleDesc(charge),
                    detailHtml: this.getDetailHtml(charge),
                    time: DC.getFormatDate(DC.getDateFromTime(charge.datetime))
                });
            };

            var items = $(this.renderByTpl(this.viewTpl.CHARGE, charges));
            items.bind(DGC.Common.E_TAP_UP, DGC.Common.listTapEndHandler)
                .bind(DGC.Common.E_TAP_DOWN , DGC.Common.listTapDownHandler)
                .bind("tap", {context: this}, this.viewChargeDetail);
            wrap.append(items);

            delete window.sdk.historyIndex;
        }

        //缓存好友下一页的游标
        this.historyCur = result.next_cursor ?  result.next_cursor : null;
    },

    /**
     * 生成记录标题
     */
    getTitleDesc : function(charge){
        var numberTpl = "<span>{0}</span><span class='amount'>{1}</span><span>{2}</span>",
            contenTpl = "<span>{0}</span>",
            title;
        switch(charge.type){
            case 0 /*乐币买道具*/:
                title = $.format(numberTpl, [resName.TEXT_CHARGEHISTORY_BUY, charge.amount, resName.TEXT_LEDOUSHOP_CURRENCY ]);
                break;
            case 1 /*充值乐币*/:
                title = $.format(numberTpl, [resName.TEXT_CHARGEHISTORY_CHARGE, charge.amount, resName.TEXT_LEDOUSHOP_CURRENCY_RMB ]);
                break;
            case 2 /*RMB买道具*/:
                title = $.format(numberTpl , [resName.TEXT_CHARGEHISTORY_BUY, charge.amount, resName.TEXT_LEDOUSHOP_CURRENCY_RMB]);
                break;
            case 4 /*兑换码兑换道具*/:
                title = $.format(contenTpl, [ resName.TEXT_CHARGEHISTORY_EX_ITEM ]);
                break;
            case 5 /*兑换码兑换乐币*/:
                title = $.format(numberTpl, [ resName.TEXT_CHARGEHISTORY_EXCHANGE , charge.amount , resName.TEXT_LEDOUSHOP_CURRENCY]);
                break;
            case 6 /*积分买道具*/:
                title = $.format(numberTpl, [resName.TEXT_CHARGEHISTORY_USE, charge.amount , resName.TEXT_LEDOUSHOP_CURRENCY_INTEGRAL]);
                break;
        }

        return title;
    },

    /**
     * 获得详情HTML结构
     */
    getDetailHtml : function(charge){
        var itemTpl = '<div class="text-field"><span class="label">{0}</span>：<span class="value">{1}</span>{2}</div>';
        var detailHtml = '';
        switch(charge.type){
            case 0 /*乐币买道具*/:
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_ITEM_NAME, charge.product_name, '']);
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_PAY_AMOUNT, charge.amount , resName.TEXT_LEDOUSHOP_CURRENCY]);
                break;
            case 1 /*充值乐币*/:
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_PAY_WAY, this.getPayMethodDesc(charge.paymethod), '']);
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_CHARGE_AMOUNT, charge.amount, resName.TEXT_LEDOUSHOP_CURRENCY_RMB ]);
                break;
            case 2 /*RMB买道具*/:
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_ITEM_NAME, charge.product_name, '']);
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_PAY_WAY, this.getPayMethodDesc(charge.paymethod), '']);
                detailHtml += $.format(itemTpl, [resName.LABEL_CHARGEHISTORY_DETAIL_PAY_AMOUNT, charge.amount, resName.TEXT_LEDOUSHOP_CURRENCY_RMB]);
                break;
            case 4 /*兑换码兑换道具*/:
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_ITEM_NAME, charge.product_name, '']);
                detailHtml += $.format(itemTpl, [resName.LABEL_CHARGEHISTORY_DETAIL_EX_AMOUNT, charge.amount , resName.TEXT_LEDOUSHOP_CURRENCY]);
                break;
            case 5 /*兑换码兑换乐币*/:
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_PAY_WAY, this.getPayMethodDesc(charge.paymethod), '']);
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_EX_AMOUNT, charge.amount, resName.TEXT_LEDOUSHOP_CURRENCY]);
                break;
            case 6 /*积分买道具*/:
                detailHtml += $.format(itemTpl,[resName.LABEL_CHARGEHISTORY_DETAIL_ITEM_NAME, charge.product_name, '']);
                detailHtml += $.format(itemTpl, [resName.LABEL_CHARGEHISTORY_DETAIL_USE_INTEGRAL, charge.amount , resName.TEXT_LEDOUSHOP_CURRENCY_INTEGRAL]);
                break;
        }

        return detailHtml;
    },


    /**
     * 获得支付方式字符串描述
     */
    getPayMethodDesc : function(method){
        var desc = null;
        switch(method){
             /*兑换码*/
             case 1:
                  desc = resName.TEXT_CHARGEHISTORY_PROMOTECODE;
                  break;
             /*易宝移动，联通，电信*/
             case 3:
                  desc = resName.TEXT_CHARGEHISTORY_YIBAO_10086;
                 break;
             case 4:
                  desc = resName.TEXT_CHARGEHISTORY_YIBAO_10010;
                 break;
             case 5:
                 desc = resName.TEXT_CHARGEHISTORY_YIBAO_10000;
                 break;
             /*支付宝*/
             case 6:
                 desc = resName.TEXT_CHARGEHISTORY_ALIPAY;
                 break;
             /*电信短代*/
             case 7:
                 desc = resName.TEXT_OFFLINECHARGE_TELECOM_SIM_PAY;
                 break;
             /*移动短代*/
             case 9:
                 desc = resName.TEXT_OFFLINECHARGE_MOBILE_SIM_PAY;
                 break;
             /*机锋*/
             case 20:
                 desc = resName.TEXT_CHARGEHISTORY_GFAN;
                 break;
             /*盛付通*/
             case 21:
                 desc = resName.TEXT_CHARGEHISTORY_SHENGPAY;
                 break;
             /*万普积分*/
             case 101:
                 desc = resName.TEXT_CHARGEHISTORY_INTEGRAL_WANGPU;
                 break;
             /*有米积分*/
             case 102:
                 desc = resName.TEXT_CHARGEHISTORY_INTEGRAL_YOUMI;
                 break;
        }

        return desc;
    },

    /**
     * 查看/收缩视图详情
     */
    viewChargeDetail : function(event){
        var context = event.data.context,
            el = $(this),
            key = $(this).attr("data-key"),
            detail;

          //查找当前点击
          for (var i = 0; i < context.cachedHistroy.length; i++) {
               detail = context.cachedHistroy[i];
               if(detail.order_id == key){
                  break;
               }
          };

          //存在展开项，则移除
          if(context.expandDetail){
              //收缩当前点击项
              var last_key = context.expandDetail.attr("data-key");
              $(".list-item[data-key='" + last_key + "']").removeClass('active');
              if(last_key == detail.order_id){
                 context.expandDetail.remove();
                 context.expandDetail = null;
                 return false;
              //收缩当前，展开其他
              }else{
                 context.expandDetail.remove();
                 context.expandDetail = $(context.renderByTpl(context.viewTpl.DETAIL_FIELD, detail));
                 el.addClass("active").after(context.expandDetail);
                 //“交易记录”界面，点击具体某条交易记录
                 DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_ME_PAYMENT_LIST_VIEW,
                    {
                       'user_id': window.sdk.player.id,
                       'order_id': detail.order_id,
                       'order_amount': detail.amount,
                       'order_channel': detail.paymethod,
                       'order_status': detail.status
                    }
                 );
              }
          //展开点击
          }else{
             context.expandDetail = $(context.renderByTpl(context.viewTpl.DETAIL_FIELD, detail));
             el.addClass("active").after(context.expandDetail);

             //“交易记录”界面，点击具体某条交易记录
             DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_ME_PAYMENT_LIST_VIEW,
                {
                   'user_id': window.sdk.player.id,
                   'order_id': detail.order_id,
                   'order_amount': detail.amount,
                   'order_channel': detail.paymethod,
                   'order_status': detail.status
                }
             );
          }
    },

    /**
     * 动态加载更多数据
     */
    scrollLoadMore : function(event){
        var context = event.data.context,
            payModel = context.action.model['pay'],
            distance = Math.abs($(window).scrollTop() -( $(document).height() - $(window).height()));

        //滚到页面底端
        if( distance <= 10){
            if(context.historyCur){
                clearTimeout(context.loadMoreTask);
                context.loadMoreTask = setTimeout(function(){
                    payModel.queryChargeHistory(25, context.historyCur);
                }, DGC.Common.DELAY_SCROLL_LOADER);

            }
        }
    },

     /**
     * 视图销毁时，移除事件监听
     */
    onDestory : function(){
        $(window).unbind("scroll", this.scrollLoadMore);
    }
});