/**
 * 充值结果页面
 */
DGC.View.ChargeResult =  $.inherits(DGC.View, {

    baseId: 'chargeresult-view',

    title: 'A_TITLE_CHARGE_ACCOUNT',

    renderTpl:'1.2.0/js/template/chargeresult.html',

    /**
     * 显示结果
     */
    chargeResult: undefined,

    /**
     * 充值失败时有效
     */
    errorDetial: undefined,

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        this.viewTpl = {
            SUCCESS: "#success-tpl",
            FAIL: "#fail-tpl"
        }

        //查询用户信息
        this.action.model['pay'].queryPlayerCoins(true);
    },


    /**
     * 充值结果转发
     */
    renderChargeResult: function(coins, history){
        if(this.chargeResult){
            this.renderChargeSuccess(coins, history[0]);
        }else{
            this.renderChargeFail(coins);
        }
    },

    /**
     * 充值成功显示最近记录
     */
    renderChargeSuccess: function(coins, record){
        var DC = DGC.Common;
        //渲染结果
        this.el.html(this.renderByTpl(this.viewTpl.SUCCESS,{
            time: DC.getFormatDate(DC.getDateFromTime(record.datetime)),
            priceText: record.amount,
            remainText: $.format(resName.TEXT_CHARGERESULT_REMAIN,['<span class="text">'+coins+'</span>'])
        }));

        this.el.find(".btn").bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')});

        //返回游戏
        $("#cr-return").bind("tap",function(){
            DGC.ActionUtil.returnToGame();
        });

        //继续充值
        $("#cr-continue").bind("tap", { context : this }, function(event){
            var context = event.data.context;
            context.action.setView("ChargeAccount",{
                chargeModel: 0
            });
        });
    },

    /**
     * 充值失败结果渲染
     */
    renderChargeFail : function(coins){
        this.el.html(this.renderByTpl(this.viewTpl.FAIL,{
           remainText:$.format(resName.TEXT_CHARGERESULT_REMAIN_FAIL,['<span class="text">'+ coins+'</span>']),
           errorDetial: this.errorDetial
        }));

        //重新充值
        $("#cr-recharge").bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){ $(this).removeClass('active')})
            .bind("tap", { context : this }, function(event){
                var context = event.data.context;
                context.action.setView("ChargeAccount",{
                    chargeModel: 0
                });
            });
    }

});
