/**
 * TA的好友列表
 */
DGC.View.FriendsToFriends =  $.inherits(DGC.View, {

    baseId : 'fd2fd-view',

    /**
     * 标题文字
     * @type Boolean
     */
    title : false,

    /**
     * 视图静态模版
     * @type String
     */
    renderTpl : "1.2.0/js/template/friendstofriends.html",

    friendsCur: undefined,

    loadMoreTask: 0,

    /**
     * 视图初始化函数
     */
    viewReady: function(){

        /**
         * 数据模板
         * @type
         */
        this.viewTpl = {
            PLAYERITEM: "#f2f-item-tpl"
        }

        var friends = this.el.find('.list-item'),
            CM = DGC.Common,
            meModel = this.action.model['me'];


        //监听scroll实现动态加载
        $(window).bind("scroll", { context : this } , this.scrollLoadMore);
        //查询好友的信息
        meModel.queryPlayerFriends(this.playerId);
    },


    /**
     * 获取需要延迟加载的图标信息
     */
    getDelayIcons : function(players){
        var delays = [];

        //delayIcons
        for (var i = 0; i < players.length; i++) {
            var player = players[i];
            if(!$.isEmpty(player.avatar_url)){
                delays.push({
                    url: player.avatar_url,
                    id: player.id
                });
            }
        };
        return delays;
    },


    /**
     * 渲染好友列表
     */
    renderFriends: function(friendsInfo , isMore){
        var friends = friendsInfo.data;
            renderedFriends  = $("#f2f-friends .list-item").size(),
            wrap = $("#f2f-friends"),
            delayIcons = null;

        //返回列表为空
        if(friends.length == 0 && !isMore ){
            //没有加载过，则当前没有关注的好友
            if(renderedFriends == 0){
                wrap.html(DGC.Common.getEmptyListItemHtml(resName.TEXT_F2FRIENDS_FOCUS_EMPTY));
            }
        }else{
            //替换字符串
            this.replacePlayedGameStaus(friends);

            delayIcons = this.getDelayIcons(friends);

            var items = $(this.renderByTpl(this.viewTpl.PLAYERITEM, friends));
            items.bind(DGC.Common.E_TAP_UP,DGC.Common.listTapEndHandler)
                 .bind(DGC.Common.E_TAP_DOWN, DGC.Common.listTapDownHandler)
                 .bind("tap", {context:this}, this.showMyFriendsDetail);
            wrap.append(items);

            //延迟加载图标
            if(delayIcons.length > 0 ){
                this.loadImages(delayIcons, function(img, data){
                    var item = $("#f2f-friends div[data-key='" + data.id + "']");
                    item.find(".default-player").replaceWith("<img src='" + img.src +"'><div class='mask'></div>");;
                });
            }

            //缓存好友下一页的游标
            this.friendsCur = friendsInfo.next_cursor ?  friendsInfo.next_cursor : null;
        }
    },

    /**
     * 替换last_game的值
     */
    replacePlayedGameStaus : function(friends){
        for (var i = 0; i < friends.length; i++) {
            var friend = friends[i];

            if(friend.id == window.sdk.player.id){
                $.extend(friend, { last_game: $.format(resName.TEXT_PLAYER_DETAIL_LASTGAME, [window.sdk.game_name])});
            }else{
                if($.isEmpty(friend.last_game)){
                    $.extend(friend,{ last_game :  resName.TEXT_PLAYER_DETAIL_LASTGAME_NONE});
                }else{
                    $.extend(friend,{ last_game :  $.format(resName.TEXT_PLAYER_DETAIL_LASTGAME,[friend.last_game]) });
                }
            }

        };
    },


    /**
     * 动态加载更多数据
     */
    scrollLoadMore : function(event){
        var context = event.data.context,
            meModel = context.action.model['me'];
            distance = Math.abs($(window).scrollTop() -( $(document).height() - $(window).height()));

        //滚到页面底端
        if(distance <= 10 && context.friendsCur != null ){
            clearTimeout(context.loadMoreTask);
            context.loadMoreTask = setTimeout(function(){
                meModel.queryPlayerFriends(context.playerId, context.friendsCur );
            }, DGC.Common.DELAY_SCROLL_LOADER);

        }
    },

    /**
     * 跳转好友详细
     */
    showMyFriendsDetail : function(event){
        var context = event.data.context,
            me = $(this),
            id = $(this).attr("data-key"),
            name = $.trim(me.find('h1').text());

        //“玩家-­‐>TA 的好友页面”界面，点击 具体某个好友
        DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_PLAYER_FRIENDS_VIEW,
            {
                'user_id':window.sdk.player.id,
                'player_id':context.playerId,
                'target_player_id':id
            }
        );

        context.action.setView('FriendsDetail',{
            title : name,
            playerId : id
        });
    },


    /**
     * 视图销毁时，移除事件监听
     */
    onDestory : function(){
        $(window).unbind("scroll", this.scrollLoadMore);
    }

});
