/**
 * 邀请好友
 */
DGC.View.InviteFriends = $.inherits(DGC.View, {

    baseId : 'invite-view',

    /**
     * 标题文字
     * @type Boolean
     */
    title : 'A_TITLE_INVITE_FRIENDS',

    /**
     * 视图静态模版
     * @type String
     */
    renderTpl : "1.2.0/js/template/invitefriends.html",

    /**
     * 视图初始化函数
     */
    viewReady: function(){
        this.viewTpl = {
            FRIENDS:"#if-friend-tpl"
        }

        //搜索按钮
        this.bindSearchBtn();

        //回退行为
        if(this.history){
            this.backToSearchStatus();
        }

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_INVITE_FRIENDS);
    },

    /**
     * 回退到搜索状态
     */
    backToSearchStatus : function(){
        this.el.find('input').val(this.history.searchKey);
        this.action.model['me'].queryMatchFriends(this.history.searchKey);
    },

    /**
     * 绑定搜索按钮
     */
    bindSearchBtn : function(){

        $("#if-search-btn").bind('tap',{ context:this }, function(event){

            //“邀请好友-­‐>搜索好友”界面，点击 “搜索按钮”
            DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_INVITE_FRIENDS_SEARCH,
                {
                    'user_id':window.sdk.player.id,
                }
            );

            var context = event.data.context;
                searchText = context.el.find('input').val();

            //搜索关键字不能为空
            if($.isEmpty(searchText)){
                DGC.ActionUtil.showTipMsg(resName.TEXT_INVITEFRIENDS_SEARCH_TIP);
                return false;
            }

            //查询好友列表
            context.action.model['me'].queryMatchFriends(searchText);
        });
    },

    /**
     * 渲染查找到的player信息
     */
    renderMatchedPlayers : function(players){
        var wrap = this.el.find(".searched-list"),
            numberWrap = $("#if-search-num");

        //先清空前一次搜索的列表
        wrap.empty();
        //搜索结果为空
        if(players.length == 0){
            numberWrap.text('');
            wrap.html(DGC.Common.getEmptyListItemHtml(resName.TEXT_INVITEFRIENDS_SEARCH_EMPTY));
        }else{
            //搜索结果数
            numberWrap.text("("+players.length+")");
            var items = $(this.renderByTpl(this.viewTpl.FRIENDS, players)),
                btns = items.find(".friend-ship-btn");
            btns.bind(DGC.Common.E_TAP_DOWN, DGC.Common.buttonTapDownHandler)
                .bind(DGC.Common.E_TAP_UP, DGC.Common.buttonTapEndHandler)
                .bind("tap", { context: this }, this.changeFriendsshipStatus);

            items.bind('tap', { context:this }, this.showFriendsDetail);

            wrap.append(items);
        }
    },

    /**
     * 显示好友详情
     */
    showFriendsDetail: function(event){
        var context = event.data.context,
            me = $(this),
            id = me.attr("data-key"),
            name = $.trim(me.find('h1').text());

        //回退恢复用户状态
        $.extend(context.initConfig, {
            history:{
                searchKey: context.el.find('input').val()
            }
        });


        //跳转至好友状态
        context.action.setView("FriendsDetail",{
            playerId: id,
            title: name
        });
    },


    /**
     * 切换关注好友状态
     */
    changeFriendsshipStatus : function(event){
        var context = event.data.context,
            me = $(this),
            isFriend = me.hasClass('keep-on'),
            id = me.parent(".list-item").attr("data-key"),
            fnName;

        fnName =  isFriend ? "updateDestoryFriendsShip" : "updateCreateFriendsShip";
        context.action.model['me'][fnName](id);
        event.stopPropagation();
    },


    /**
     * 更新当前玩家状态
     */
    updateFriendsship: function(shipStatus , targetId){
        var btn = $(".list-item[data-key='"+ targetId + "'] .friend-ship-btn");
        if(shipStatus){
            btn.removeClass('blue-btn').addClass('silver-btn keep-on');
            btn.text(resName.TEXT_ME_DETAIL_FOCUS_CANCEL);
        }else{
            btn.removeClass('keep-on silver-btn').addClass('blue-btn');
            btn.text(resName.TEXT_ME_DETAIL_FOCUS_FRIEND);
        }
    }
});
