/**
 * 我的好友/粉丝/信息列表信息
 */
DGC.View.MyFriends = $.inherits(DGC.View, {

    baseId: 'myfrends-info',

    title: 'A_TITLE_MY_FRIENDS',

    renderTpl:'1.2.0/js/template/myfriends.html',

    defaultTab: 'mf-friends',

    currentTab: undefined,

    friendsCur: undefined,

    fansCur: undefined,

    loadMoreTask: 0,

    /**
     * 视图初始化函数
     */
    viewReady: function(){

        this.viewTpl = {
            PLAYERITEM:"#mf-item-tpl"
        };

        /**
         * 记录已渲染的子模块
         */
        this.subRendered = {
            "myFriends": false,
            "myFans":  false
        };

        //绑定切换Tab事件
        this.bindTabItems();

        //存在新的粉丝Tips提示
        if(window.sdk.tips && window.sdk.tips.hasOwnProperty('new_follwers')){
            this.setNewFans();
        }

        //搜索好友
        this.bindSearchFriendsBtn();

         //分享游戏
        this.bindShareBtn();

        //默认加载Tab
        $("#" +this.defaultTab).trigger('tap', { context: this} );

        //监听scroll实现动态加载
        $(window).bind("scroll", { context : this } , this.scrollLoadMore);

        //DEMO绑定
        //this.bindFriendDetail();

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_FRIENDS);

    },

    /**
     * 邀请好友按钮
     */
    bindSearchFriendsBtn: function(){
        //搜素好友
        var btn = $("#if-search-btn");

        btn.bind(DGC.Common.E_TAP_DOWN,function(){
            $(this).addClass('active');
        }).bind(DGC.Common.E_TAP_UP,function(){
            $(this).removeClass('active');
        }).bind('tap',{context: this}, function(event){
            var context = event.data.context;
                searchText = context.el.find('input').val();

            //搜索关键字不能为空
            if($.isEmpty(searchText)){
                DGC.ActionUtil.showTipMsg(resName.TEXT_INVITEFRIENDS_SEARCH_TIP);
                return false;
            }

            //记录点：“邀请好友->搜索好友”界面，点击 “搜索按钮”
            DGC.ActionUtil.recordUserAction(
                DGC.Event.EventId.EVENT_INVITE_FRIENDS_SEARCH,
                {
                    'user_id':window.sdk.player.id
                }
            );

            //预跳转搜索
            context.action.setView('InviteFriends',{
                history:{
                    searchKey: searchText
                }
            });
        });
    },


    /**
     * 分享好友
     */
    bindShareBtn: function(){
        var DC = DGC.Common;
        $("#share-btn").bind(DC.E_TAP_DOWN,DC.buttonTapDownHandler)
            .bind(DC.E_TAP_UP,DC.buttonTapEndHandler)
            .bind('tap',{context: this}, this.showInviteFriend);
    },

    /**
     * 显示新邀请数
     */
    setNewFans: function(){
        //清空Fans的TIPS提示
        var tips = window.sdk.tips,
            totals = 0;

        for(var key in tips){
            totals = totals + tips[key];
        }

        //显示剩余TIPS
        DGC.ActionUtil.updateTabTip(DGC.Module.ATTRS.ME, totals - tips.new_follwers);

        //缓存需要标识的值
        window.sdk.historyFansNum  = parseInt( tips.new_follwers , 10);
        window.sdk.exceptIDs = []; //需要排除的ID

        //第一次进入显示TIP值
        /*
        if(newFansNum){
            this.el.find("span.new-fans").text("(" + newFansNum +")");
        }*/
    },

    /**
     * 清除fans数
     */
    clearNewFans: function(){
        delete  window.sdk.tips.new_follwers;
        //this.el.find("span.new-fans").text("");
    },

    /**
     *  Tab导航绑定
     */
    bindTabItems : function(){
        var tabs = this.el.find('.common-tab-nav li');
        tabs.bind('tap',{ context : this }, function(event){
            var context = event.data.context,
                el = $(this),
                meModel = context.action.model['me'];

            if(context.currentTab){
                //隐藏当期Tab Element
                $("#" + context.currentTab).removeClass('tab-active');
                //隐藏
                context.getContentEl(context.currentTab).hide();
            }
            //激活当前点击Tab
            el.addClass('tab-active');
            //显示对应的Tab Content内容
            context.getContentEl(el.attr("id")).show();
            context.currentTab = el.attr("id");

            switch(context.currentTab){
                case "mf-friends":

                    //“我的好友”界面，点击 “好友分类”
                    DGC.ActionUtil.recordUserAction(
                        DGC.Event.EventId.EVENT_ME_FRIENDS_CATEGORY,
                        {
                            'user_id':window.sdk.player.id,
                            'friends_category_id':DGC.Event.Option.FRIEND_CATEGORY_FOLLOW
                        }
                    );

                    if(!context.subRendered.myFriends){
                        meModel.queryPlayerFriends(context.player.id, context.friendsCur );
                    }
                    break;
                case "mf-fans":

                    //“我的好友”界面，点击 “好友分类”
                    DGC.ActionUtil.recordUserAction(
                        DGC.Event.EventId.EVENT_ME_FRIENDS_CATEGORY,
                        {
                            'user_id':window.sdk.player.id,
                            'friends_category_id':DGC.Event.Option.FRIEND_CATEGORY_FANS
                        }
                    );

                    //存在新的粉丝Tips提示
                    if(window.sdk.tips && window.sdk.tips.hasOwnProperty('new_follwers')){
                        context.clearNewFans();
                    }

                    if(!context.subRendered.myFans){
                        meModel.queryPlayerFollowers(context.player.id, context.fansCur);
                    }
                    break;
            }
        });
    },

    /**
     * 获取contentEL对象
     * @param {String} id Tab导航元素的id 属性
     */
    getContentEl : function(id){
        return $("#" + id + "-content");
    },

    /**
     * 获取需要延迟加载的图标信息
     */
    getDelayIcons : function(players){
        var delays = [];

        //delayIcons
        for (var i = 0; i < players.length; i++) {
            var player = players[i];
            if(!$.isEmpty(player.avatar_url)){
                delays.push({
                    url: player.avatar_url,
                    id: player.id
                });
            }
        };
        return delays;
    },

    /**
     * 渲染好友列表
     */
    renderMyFriends : function(friendsInfo , isMore ){
        var friends = friendsInfo.data;
            renderedFriends  = $("#mf-friends-content .list-item").size(),
            wrap = $("#mf-friends-content"),
            btnWrap = $(".search-friends-bar"),
            delayIcons = null;

        //返回列表为空
        if(friends.length == 0 && !isMore ){
            //没有加载过，则当前没有关注的好友
            if(renderedFriends == 0){
                wrap.prepend(DGC.Common.getEmptyListItemHtml($.format(resName.TEXT_MYFRIENDS_MYFOCUS_EMPTY,[window.sdk.game_name])));
            }
        }else{
            //替换last_game状态
            this.replacePlayedGameStaus(friends);
            delayIcons = this.getDelayIcons(friends);

            var items = $(this.renderByTpl(this.viewTpl.PLAYERITEM, friends));
            items.bind(DGC.Common.E_TAP_UP,DGC.Common.listTapEndHandler)
                 .bind(DGC.Common.E_TAP_DOWN, DGC.Common.listTapDownHandler)
                 .bind("tap", {context:this}, this.showMyFriendsDetail);

            //显示在邀请按钮之前
            btnWrap.before(items);

            //延迟加载图标
            if(delayIcons.length > 0 ){
                this.loadImages(delayIcons, function(img, data){
                    var item = $("#mf-friends-content div[data-key='" + data.id + "']");
                    item.find(".default-player").replaceWith("<img src='" + img.src +"'><div class='mask'></div>");;
                });
            }

            //缓存好友下一页的游标
            this.friendsCur = friendsInfo.next_cursor ?  friendsInfo.next_cursor : null;
        }

        this.subRendered.myFriends = true;
    },

    /**
     * 渲染粉丝列表
     */
    renderMyFans : function (fansInfo , isMore){
        var fans = fansInfo.data,
            renderedFans  = $("#mf-fans-content .list-item").size(),
            newFansNum  = window.sdk.historyFansNum || 0 ,
            wrap = $("#mf-fans-content"),
            delayIcons = null;

        //返回fans数为0
        if( fans.length == 0 && !isMore ){
            //第一次渲染
            if(renderedFans == 0){
                 wrap.html(DGC.Common.getEmptyListItemHtml(resName.TEXT_MYFRIENDS_MYFANS_EMPTY));
            }
        }else{
            //存在还未渲染的新Fans
            if(newFansNum != 0 && newFansNum != window.sdk.exceptIDs.length && newFansNum > renderedFans){
                //每次加载25条
                var needMarkNum  = (newFansNum - renderedFans) > 25 ? fans.length : (newFansNum - renderedFans);

                for (var i = 0; i < needMarkNum; i++) {
                      //已经查看过点击过的Player不高亮
                      if($.inArray(fans[i].id, window.sdk.exceptIDs) != -1) continue;
                      fans[i] = $.extend( fans[i] , { isNew: true });
                };
            }

            //替换last_game状态
            this.replacePlayedGameStaus(fans);
            delayIcons = this.getDelayIcons(fans);

            var items = $(this.renderByTpl(this.viewTpl.PLAYERITEM, fans));
            items.bind(DGC.Common.E_TAP_UP,DGC.Common.listTapEndHandler)
                 .bind(DGC.Common.E_TAP_DOWN, DGC.Common.listTapDownHandler)
                 .bind("tap", {context:this}, this.showMyFriendsDetail);

            //渲染HTML
            wrap.append(items);

            //延迟加载图标
            if(delayIcons.length > 0 ){
                this.loadImages(delayIcons, function(img, data){
                    var item = $("#mf-fans-content div[data-key='" + data.id + "']");
                    item.find(".default-player").replaceWith("<img src='" + img.src +"'><div class='mask'></div>");;
                });
            }

            //缓存粉丝下一页的游标
            this.fansCur = fansInfo.next_cursor ?  fansInfo.next_cursor : null;
        }

        this.subRendered.myFans = true;
    },

    /**
     * 替换last_game的值
     */
    replacePlayedGameStaus : function(friends){
        for (var i = 0; i < friends.length; i++) {
            var friend = friends[i];
            if($.isEmpty(friend.last_game)){
                $.extend(friend,{ last_game :  resName.TEXT_PLAYER_DETAIL_LASTGAME_NONE});
            }else{
                $.extend(friend,{ last_game :  $.format(resName.TEXT_PLAYER_DETAIL_LASTGAME,[friend.last_game]) });
            }
        };
    },

    /**
     * 动态加载更多数据
     */
    scrollLoadMore : function(event){
        var context = event.data.context,
            meModel = context.action.model['me'],
            distance = Math.abs($(window).scrollTop() -( $(document).height() - $(window).height()));

        DGC.ActionUtil.log("page scroll:" + $(window).scrollTop());
        DGC.ActionUtil.log("loader point:" + ($(document).height() - $(window).height()) );
        //滚到页面底端
        if( distance <= 10){
            if(context.currentTab == "mf-friends" && context.friendsCur != null){
                clearTimeout(context.loadMoreTask);
                context.loadMoreTask = setTimeout(function(){
                    meModel.queryPlayerFriends(context.player.id, context.friendsCur );
                }, DGC.Common.DELAY_SCROLL_LOADER);
            }else if(context.currentTab == "mf-fans" && context.fansCur != null){
                clearTimeout(context.loadMoreTask);
                context.loadMoreTask = setTimeout(function(){
                    meModel.queryPlayerFollowers(context.player.id, context.fansCur);
                }, DGC.Common.DELAY_SCROLL_LOADER);
            }
        }
    },

    /**
     * 跳转好友详细
     */
    showMyFriendsDetail : function(event){
        var context = event.data.context,
            me = $(this),
            id,
            name;
        id = me.attr("data-key");
        name = $.trim(me.find('h1').text());

        //“我的好友”界面，点击 具体某个好友
        DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_ME_FRIENDS_VIEW,
            {
                'user_id':window.sdk.player.id,
                'friend_id':id
            }
        );

        //回退恢复用户状态
        $.extend(context.initConfig, {
            defaultTab: context.currentTab
        });

        //已经查看过的好友，下次查看列表时，将不 mark为新粉丝
        if(me.hasClass("list-item-highlight")){
            window.sdk.exceptIDs.push(id);
        }

        context.action.setView('FriendsDetail',{
            playerId: id,
            title: name
        });
    },


    /**
     * 分享按钮
     */
    showInviteFriend : function(event){
        var context = event.data.context;

        //记录点：“我的好友”界面，点击 “分享”
        DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_ME_FRIENDS_INVITE,
            {
                'user_id':window.sdk.player.id
            }
        );

        //弹出分享窗口
        context.action.showDialog(
            "ShareGame",
            {
                meModel: context.action.model['me'],
                notBindCallback : $.bindFn(context.bindAccount, context) //没有sns绑定帐号执行
            },
            function(name, params){
                //弹出绑定的Dialog
                this.shareWin = new DGC.Dialog[name](params);
                this.shareWin.show();
            },
            context
        );
    },

    /**
     * 模板内容Ready
     */
    contentReadyProxy: function(content){
        if(this.shareWin){
            this.shareWin.contentReady(content);
        }
    },

    /**
     * 发送SNS成功
     */
    sendSNSSuccessProxy: function(type,result){
        if(this.shareWin){
            this.shareWin.sendSNSSuccess(type,result);
        }
    },

    /**
     * 绑定sns帐号
     */
    bindAccount: function(type){
        var ATTR = DH.ATTR;
        DGC.ActionUtil.log("account type :" + type);
        if (type == ATTR.BIND_SNS.SINA){
            this.action.showDialog(
                    "SinaDialog",
                    {
                        meModel: this.action.model['me'],
                    },
                    function(name, params){
                        //弹出绑定的Dialog
                        this.sina = new DGC.Dialog[name](params);
                        this.sina.show();
                    },
                    this);
        } else if (type == ATTR.BIND_SNS.RENREN){
            this.action.showDialog(
                    "RenRenLoginDialog",
                    {
                        meModel: this.action.model['me'],
                    },
                    function(name, params){
                        //弹出绑定的Dialog
                        this.renren = new DGC.Dialog[name](params);
                        this.renren.show();
                    },
                    this);
        }

    },

    /**
     * 视图销毁时，移除事件监听
     */
    onDestory : function(){
        $(window).unbind("scroll", this.scrollLoadMore);
        if(this.shareWin){
             this.shareWin.destory();
             this.shareWin = null;
        }

        if(this.renren){
            this.renren.destory();
            this.renren = null;
        }

        if(this.sina){
            this.sina.destory();
            this.sina = null;
        }

    }

});
