/**
 * 排行榜视图(离线)
 */
DGC.View.OfflineBoard =  $.inherits(DGC.View, {

    baseId:'offlineboard-view',

    /**
     * 排行榜不支持标题文字
     * @type Boolean
     */
    title : false,

    /**
     * 默认不显示Back按钮
     */
    isSub: false,


    renderTpl : "1.2.0/js/template/offlineboard.html",

    leaderBoard: undefined,

    boardList: undefined,

    /**
     * 排行模式后退显示
     */
    boardsSub : false,

    /**
     * 视图显示模式
     * 0:SDK页面
     * 1:游戏开发者界面
     */
    model: 0,

    /**
     * 视图初始化函数
     */
    viewReady: function(){

        this.viewTpl= {
            RANKTPL:"#my-rank-tpl"
        }

        this.bindReloginBtn();

        //查询指定排榜数据
        if(this.leaderBoard){
            this.triggerHighScore(this.leaderBoard);
        //查询排行榜列表，获得默认排行榜
        }else{
            this.action.model['hs'].queryOfflineBoardModel();
        }

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_LEADERBOARD_LOCAL);
    },

    /**
     * 离线重登录按钮绑定
     */
    bindReloginBtn : function(){
        $("#offline-relogin").bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')})
            .bind("tap", { context: this } , function(event){
                DGC.ActionUtil.offlineRelogin();
            });
    },

    /**
     * 获得当前默认的排行模式,并请求默认排行模式的详细信息
     * @param {Array} boardList 当前游戏的排行列表
     */
    findDefaultBoard : function(boardList){
        //缓存排行模式
        this.boardList = boardList;

        //游戏没有排行模式
        if(boardList.length == 0){
            this.setTitle($.format(resName.A_TITLE_BOARD, [window.sdk.game_name] ));
            this.el.html("<div class=\"common-error-wrap center-layout\"><h1>" + resName.TEXT_DASHBOARD_EMPTY_MODEL+"</h1></div>");
            return false;
        //多种排行模式
        }else if(boardList.length > 1){
            this.action.setView("BoardCategory",{
                game  : this.game,
                player : this.player,
                boardList  : boardList
            }, false /*不重置视图*/, true /*不保存当前视图*/);
        //只有一种排行模式
        }else if(boardList.length == 1){
            this.leaderBoard = boardList[0];
            this.triggerHighScore(boardList[0]);
        }
    },

    /**
     * 查询默认高分榜的基本信息
     */
    triggerHighScore : function(board){
        //设置标题
        this.setTitle(board.title);
        //默认查询好友高分榜信息
        this.action.model['hs'].queryOfflineRankList(board.identifier);
    },

    /**
     * 渲染我的排行渲染
     * @param {Array} myRank 我的排行列表
     */
    renderRankList : function(myRank){
        var wrap = this.el.find(".rank-postion");
        if(myRank.length == 0){
            wrap.html(DGC.Common.getEmptyListItemHtml(resName.TEXT_DASHBOARD_EMPTY_LIST));
        }else{
            //渲染Player的排名
            var renderHTML = this.renderByTpl(this.viewTpl.RANKTPL, myRank);
            wrap.append(renderHTML);
        }

    }

});
