/**
 * 离线短代支付模式
 */
DGC.View.OfflineCharge =  $.inherits(DGC.View, {

    baseId: 'offline-charge-view',

    title: 'A_TITLE_PAY_ACCOUNT',

    renderTpl:'1.2.0/js/template/offlinecharge.html',

    /**
     * 支付道具信息
     */
    orderInfo: undefined,

    /**
     * 视图初始化函数
     */
    viewReady: function(){

        this.el.find(".list-item").bind(DGC.Common.E_TAP_DOWN, DGC.Common.listTapDownHandler)
            .bind(DGC.Common.E_TAP_UP,DGC.Common.listTapEndHandler);

        $("#oc-ct-msg").bind('tap',{context: this, type : 7 /*电信短代*/}, this.offLinePayHandler);

        $("#oc-mb-msg").bind('tap',{context: this, type : 9 /*移动短代*/}, this.offLinePayHandler);

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_PAYMENT_CHARGE_OFFLINE);
    },

    /**
     * 离线支付
     */
    offLinePayHandler:function(event){
        var context = event.data.context,
            paymethod = event.data.type;

       //离线购买道具界面，点击具体的支付方式
       DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_ME_PAYMENT_CHARGE_ACTION,
            {
                'user_id': (window.sdk.player ? window.sdk.player.id : null) ,
                'charge_channel':(function(type){
                    var typeId,
                        OP = DGC.Event.Option;
                    switch(type){
                         /*电信短代*/
                         case 7:
                             typeId = OP.CHARGE_DIANXIN_PHONE;
                             break;
                         /*移动短代*/
                         case 9:
                             typeId = OP.CHARGE_YIDONG_PHONE;
                             break;
                    }
                    return typeId;
                })(paymethod)
            }
        );

        context.action.model['pay'].payOrderByLocal(paymethod,{
            quantity: context.orderInfo.quantity,
            item: context.orderInfo.item
        });
    },

    /**
     * 离线短代支付后结果回调
     */
    payByLocalResult: function(result, detail){
        //跳转显示充值结果
        this.action.setView("PayResult",{
            result: result,
            payInfo: detail
        });
    }

});