/**
 * 设置/修改密码
 */
DGC.View.PassModify =  $.inherits(DGC.View, {

    baseId: 'pass-modify-view',

    title: 'A_TITLE_PASS_MODIFY',

    renderTpl:'1.2.0/js/template/passmodify.html',

    /**
     * 密码修改模式
     * 枚举：
     * 0:设置密码
     * 1:修改密码
     */
    modifyModel: 0, //默认设置密码

    /**
     * 视图初始化函数
     */
    viewReady: function(){
         var ATTRS = DGC.View.PassModify.ATTRS ,
              memuTitle, formTpl;

        this.modifyModel = ( DH.isPhoneBound() ? ATTRS.MODIFY_MODEL.MODIFY /*已绑定*/ : ATTRS.MODIFY_MODEL.SET /*未绑定*/ );
        switch(this.modifyModel){
            case ATTRS.MODIFY_MODEL.SET:
                memuTitle = resName.TITLE_PASSMODIFY_SETTTING_PASS;
                formTpl = $("#set-pass-tpl");
                break;
            case ATTRS.MODIFY_MODEL.MODIFY:
                memuTitle = resName.TITLE_PASSMODIFY_MODIFY_PASS;
                formTpl = $("#modify-pass-tpl");
                break;
        }

        $("#pm-modify-title").text(memuTitle);
        $("#pass-modify").prepend(formTpl.html());

        //提示原手机号
        if(this.modifyModel == ATTRS.MODIFY_MODEL.MODIFY){
            $("#modify-mobileNumber").attr("placeholder",window.sdk.security.phone);
        }

        //只允许输入数字
        this.el.find("input[type='number']").keypress(DGC.Common.onlyAllowNumber);

        $("#pass-modify").bind('submit',{context:this},function(event){
            var context = event.data.context;
            var mobilephoneReg = /(^0?[1][358][0-9]{9}$)/;
            switch(context.modifyModel){
                case ATTRS.MODIFY_MODEL.SET:
                    var mobileNumber = $("#set-mobileNumber").val();
                    var password = $("#set-password").val();
                    var confirm = $("#set-confirm").val();
                    //手机号码不为空
                    if($.isEmpty(mobileNumber)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_MOBILE_NUMBER);
                        return false;
                    }
                    //手机号码格式不正确
                    if(!mobilephoneReg.test(mobileNumber)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_MOBILE_FORMAT_ERROR);
                        return false;
                    }

                    //密码不为空
                    if($.isEmpty(password)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_PASSWORD);
                        return false;
                    }

                    //确认密码不为空
                    if($.isEmpty(confirm)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_CONFIRM);
                        return false;
                    }

                    //两次密码不一致
                    if(password!=confirm){
                        DGC.ActionUtil.showTipMsg(resName.TIP_SET_PASSWORD_CONFIRM);
                        return false;
                    }

                    //提交给feed处理
                    context.action.model['me'].updateSetPass(mobileNumber,password);
                    break;
                case ATTRS.MODIFY_MODEL.MODIFY:
                    var oldpassword = $("#modify-old-password").val(),
                        newpassword = $("#modify-new-password").val(),
                        confirm = $("#modify-confirm").val(),
                        phoneNumber = $("#modify-mobileNumber").val();

                    //旧密码不为空
                    if($.isEmpty(oldpassword)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_MODIFY_OLD_PASSWORD);
                        return false;
                    }

                    //新密码不为空
                    if($.isEmpty(newpassword)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_MODIFY_NEW_PASSWORD);
                        return false;
                    }

                    //确认密码不为空
                    if($.isEmpty(confirm)){
                        DGC.ActionUtil.showTipMsg(resName.TIP_MODIFY_CONFIRM);
                        return false;
                    }

                    //两次密码不一致
                    if(newpassword != confirm){
                        DGC.ActionUtil.showTipMsg(resName.TIP_MODIFY_PASSWORD_CONFIRM);
                        return false;
                    }

                    //判断是否有修改手机号
                    if(!$.isEmpty(phoneNumber) && phoneNumber != window.sdk.security.phone){
                        //手机号码格式不正确
                        if(!mobilephoneReg.test(phoneNumber)){
                            DGC.ActionUtil.showTipMsg(resName.TIP_SET_MOBILE_FORMAT_ERROR);
                            return false;
                        }
                        DGC.Common.confirm(resName.TIP_PASSMODIFY_PHONENUMBER_CONFIRM_TITLE, $.format(resName.TIP_PASSMODIFY_PHONENUMBER_CONFIRM_MSG, [phoneNumber]), function(result) {
                            if(result) {
                                context.action.model['me'].updateModifyPass({
                                    "old_password" : oldpassword,
                                    "new_password" : newpassword,
                                    "phone" : phoneNumber
                                });
                            }
                        });
                    }else{
                        //提交给feed处理
                        context.action.model['me'].updateModifyPass({
                            "old_password": oldpassword,
                            "new_password": newpassword
                        });
                    }
                    break;
            }
            return false;
        });

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_ME_ACCOUNT);

    }

});

DGC.View.PassModify.ATTRS = {

    MODIFY_MODEL: {

        SET: 0,

        MODIFY: 1
    }
}

