/**
 * 易宝支付页面
 */
DGC.View.PayCommit =  $.inherits(DGC.View, {

    baseId: 'pay-commit-view',

    title: 'A_TITLE_PAY_ACCOUNT',

    renderTpl:'1.2.0/js/template/yibaocommit.html',

    payWay: undefined,

    /**
     * 订单信息
     */
    orderInfo: undefined,

    /**
     * 有且只有一种支付模式
     */
    onlyPay:false,


    /**
     * 视图初始化函数
     */
    viewReady: function(){

        this.chargedAccount = [];

        this.viewTpl = {
            ITEM_DEAIL:"#item-detail-tpl"
        }

        //电信/联通/移动卡号密码位数限制
        this.limitConifg = {
            //移动
            v3:{
                cardNumber: 17,
                password: 18
            },
            //联通
            v4:{
                cardNumber: 15,
                password: 19
            },
            //电信
            v5:{
                cardNumber: 19,
                password: 18
            }
        }

        /* 乐币数(单价*数量)*汇率*折扣 = 实际需要支出的金额 */
        var miniCharge  = DGC.Common.currencyFormat( this.orderInfo.quantity * this.orderInfo.item.product.price * this.payWay.rate * this.payWay.discount , 2);

        //购买道具栏信息(当前只支持一个道具)
        this.el.prepend(this.renderByTpl(this.viewTpl.ITEM_DEAIL, {
            productName:this.orderInfo.item.product.name,
            needPayCoins: miniCharge,
            hasCoins: window.sdk.player.coins,
            icon: this.orderInfo.item.product.icon
        }));

        //Top Bar 文本信息
        this.el.find(".charge-type-tip").html($.format(resName.TEXT_CHARGECOMMIT_PAYWAY,["<span>\""+ this.payWay.name +"\"</span>"]));

        //设置最大位数限制,empty内容
        var cardField = this.el.find("input[name='cardNumber']"),
            passField = this.el.find("input[name='password']"),
            maxConfig = this.limitConifg['v'+this.payWay.identifier];
        cardField.attr("maxlength", maxConfig.cardNumber);
        passField.attr("maxlength", maxConfig.password);
        cardField.attr("placeholder",$.format(resName.TEXT_CHARGECOMMIT_CARD_NUM_TIP,[maxConfig.cardNumber]));
        passField.attr("placeholder",$.format(resName.TEXT_CHARGECOMMIT_CARD_PASS_TIP,[maxConfig.password]));
        cardField.keypress(DGC.Common.onlyAllowNumber);
        passField.keypress(DGC.Common.onlyAllowNumber);

        //渲染支付列表
        this.renderPayValues(miniCharge);

        //充值按钮
        $("#yibao-pay").bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')})
            .bind("tap", { context: this }, this.payActionHandler);

        //帮助按钮
        $("#pay-help").bind(DGC.Common.E_TAP_DOWN,function(){$(this).addClass('active')})
            .bind(DGC.Common.E_TAP_UP,function(){$(this).removeClass('active')})
            .bind("tap", { context: this }, function(event){
                var context = event.data.context;

                //“具体某一渠道支付”界面，点击帮助 （如果有该界面）
                DGC.ActionUtil.recordUserAction(
                    DGC.Event.EventId.EVENT_MALL_PURCHASE_DETAIL_HELP,
                    {
                        'user_id': window.sdk.player.id,
                        'purchase_channel': DGC.Event.Util.getPayEvent(context.payWay.identifier)
                    }
                );

                context.action.showDialog( "PayHelpDialog", { payWay:context.payWay },  function(name, params){
                    //弹出绑定的Dialog
                    new DGC.Dialog[name](params).show();
                }, context);
            });

        //记录页面访问次数
        DGC.ActionUtil.recordPageCount(DGC.Event.PageId.SKYNET_PAGE_MALL_PURCHASE_DETAIL);
    },

    /**
     * 自定义Back函数
     */
    backAction : function(){
        //只有一种支付方式，直接返回游戏
        if(this.onlyPay){
            DGC.ActionUtil.returnToGame();
            return false;
        }else{
            return true;
        }
    },

    /**
     * 渲染可选金额项
     * @param {Number} miniValue 最小支付金额
     */
    renderPayValues : function(miniValue){
        var selectValue = "{0}"+ resName.TEXT_MYPURSE_UNIT,
            options = this.payWay.list_values,
            optionLabels = [],
            selectEl = $("#yibao-payvalues");

        //下拉选项框拼接结构
        for (var i = 0; i < options.length; i++) {
            var realValue = this.payWay.actual_values[i];
            //选项少于最小金额,不显示
            if(realValue < miniValue ) continue;
            optionLabels.push($.format("<option value={0}>",[ realValue ]));
            optionLabels.push($.format(selectValue,[ options[i] ]));
            optionLabels.push("</option>");
        };

        var optionEls = optionLabels.join('');
        selectEl.append(optionEls);

        //下拉选项事件
        selectEl.bind("change", {context:this},function(event){
            var context = event.data.context,
                changeEl = $(this).children("option:selected"),
                labelOption = context.el.find(".select-text");
            labelOption.text(changeEl.text());
        });

        //默认选择项
        this.el.find(".select-text").text(selectEl.children("option:first").text());
    },

    /**
     * 支付按钮
     */
    payActionHandler : function(event){
       var context = event.data.context,
           DAU = DGC.ActionUtil,
           account = context.el.find("input[name='cardNumber']").val(),
           password = context.el.find("input[name='password']").val(),
           money = $("#yibao-payvalues option:selected").val();


        //“具体某一渠道充值”界面，点击充值
        DGC.ActionUtil.recordUserAction(
            DGC.Event.EventId.EVENT_MALL_PURCHASE_DETAIL_PURCHASE,
            {
                'user_id': window.sdk.player.id,
                'charge_amount' : money,
                'purchase_channel': DGC.Event.Util.getPayEvent(context.payWay.identifier)
            }
        );

         //卡号不能为空
        if($.isEmpty(account)){
            DAU.showTipMsg(resName.TIP_CHARGECOMMIT_ACCOUNT_NOT_NULL);
            return false;
        }

        //卡密不能为空
        if($.isEmpty(password)){
            DAU.showTipMsg(resName.TIP_PASSWORD_NOT_NULL);
            return false;
        }

        //验证卡密位数
        var cardVerify = context.limitConifg['v'+context.payWay.identifier];
        if(account.length  != cardVerify.cardNumber){
            DAU.showTipMsg($.format(resName.TIP_CHARGECOMMIT_INVAIL_CARDNUM, [ cardVerify.cardNumber ]));
            return false;
        }
        if(password.length != cardVerify.password){
            DAU.showTipMsg($.format(resName.TIP_CHARGECOMMIT_INVAIL_PASSWORD, [ cardVerify.password ]));
            return false;
        }

        if(context.isChargedAccount(account, password)){
            DAU.log(resName.TIP_CHARGE_PAY_COMMIT_USED_CARD);
            DAU.showTipMsg(resName.TIP_CHARGE_PAY_COMMIT_USED_CARD);
            return false;
        }

        //易宝支付
        context.action.model['pay'].payOrderByFeed(context.payWay.identifier,{
             card_no: account,
             card_pwd: password,
             quantity: context.orderInfo.quantity,
             product_id: context.orderInfo.item.product.id,
             recharge: money
        }, context.orderInfo.item);
    },

    /**
     * 是否为充值过的卡密
     * @params cardNo {String} 卡号
     * @params password {String} 密码
     */
    isChargedAccount: function(cardNo, password){
        for(var i = 0 ; i < this.chargedAccount.length; i++){
            var charged = this.chargedAccount[i];
            if(charged.card_no == cardNo && charged.card_pwd == password ){
                return true;
            }
        }

        return false;
    },

    /**
     * FEED API支付后结果回调(易宝)
     * @param {Boolean} result 充值结果
     * @param {object} detail 支付方式以及提示
     * @param {Object} failitem 支付失败的item对象
     */
    payByYiBaoResult: function(result, detail , failitem){
        var DAU = DGC.ActionUtil;
        //易宝支付
        if(detail.paymethod >= 3 && detail.paymethod <= 5 ){
            //易宝等待消息通知,发送充值请求成功
            if(result){
                //缓存已下单成功的卡密
                this.chargedAccount.push({
                    card_no: detail.card_no,
                    card_pwd: detail.card_pwd
                });

                //移除冗余属性
                delete detail.card_no;
                delete detail.card_pwd;

                DAU.notifySDKBuyResult(3 /*支付宝/易宝*/, result, detail);

                DAU.showTipMsg($.format(resName.TIP_CHARGECOMMIT_YIBAO_SUCCESS, [detail.id]),function(){
                    //回退乐逗商城页/开发者入口直接返回游戏
                    DGC.Application.goBack(2);
                });
            }else{
                this.action.model['pay'].showPayErrorDetail(detail);
                //通知SDK支付操作失败
                DAU.notifySDKBuyResult(3 /*支付宝/易宝*/, result, failitem, detail.err_code);
            }
        }
    }

});
