/**
 * 购买道具详情框
 * 乐逗商城和开发者购买页面使用
 */
DGC.Dialog.ShopDetail = $.inherits(DGC.Dialog, {

    baseId: "shop-detail",

    /**
     * 确认框模板
     */
    renderTpl : "1.2.0/js/template/dialog/shopdetail.html",


    orderItem: undefined,

    /**
     * 禁止购买
     */
    disableAction: false,


    callback: $.emptyFn,

    /**
     * 积分支付对象
     */
    integral: undefined,

    /**
     * 积分不足时，是否关闭当前窗口(默认关闭)
     */
    integralAction: true,

    viewReady: function(){
        var product = this.orderItem.product,
            context = this;


        this.el.find(".buy-detail .name").text(product.name);
        this.el.find(".buy-detail .price .value").text(product.price);

        this.el.find(".body .content h2").text(product.description);

        this.bindIntegralBtn();

        //延时加载图标
        if(!$.isEmpty(product.icon)){
            this.parentView.loadImages({url: product.icon }, function(img, data){
                context.el.find(".icon").html("<img src='" + img.src + "'/><div class='mask'></div>");
            });
        }

        //支持乐币，则显示余额
        if(window.sdk.channel.enable_coin_payment){
            this.el.find(".buy-detail .playercoins .value").text(window.sdk.player.coins);
        }else{
            this.el.find(".buy-detail .playercoins").hide();
        }

        var buyBtn = this.el.find(".btn-ok");
        //已购买，禁止购买
        if(this.disableAction){
            buyBtn.css("opacity", 0.5);
        }else{
            //确认按钮
            buyBtn.bind(DGC.Common.E_TAP_DOWN,function(){
                $(this).addClass('active');
            }).bind(DGC.Common.E_TAP_UP,function(){
                $(this).removeClass('active');
            }).bind("tap", { context: this }, function(event){
                var context = event.data.context;
                setTimeout( $.bindFn(context.destory, context) , 500 );
                context.callback(true);

                //“乐逗商城”提示购买确认框界面，点击”购买”
                DGC.ActionUtil.recordUserAction(DGC.Event.EventId.EVENT_MALL_PURCHASE_ALERT_ACTION,{
                    'user_id': (window.sdk.player ?  window.sdk.player.id : null ) ,
                    'game_id': (window.sdk.game ?  window.sdk.game.id : null ),
                    'product_id': product.identifier,
                    'selected_type': DGC.Event.Option.BUTTON_PURCHASE
                });
            });
        }

    },

    /**
     * 绑定积分按钮
     */
    bindIntegralBtn: function(){
        var btn = this.el.find(".btn-integralbuy"),
            valueEl = this.el.find(".btn-integralbuy .value"),
            closeBtn = this.el.find(".close-btn"),
            cancelBtn = this.el.find(".btn-cancel"),
            buyBtn = this.el.find(".btn-ok"),
            DC = DGC.Common,
            costIntegral;

        //积分对象
        if(this.integral != null){
            costIntegral = this.orderItem.product.price * this.integral.rate * this.integral.discount;
            valueEl.text($.format(resName.TIP_SHOPDETAIL_COSTINTEGRAL,[costIntegral ]));

            //禁止兑换
            if(this.disableAction){
                btn.css("opacity", 0.5);
            }else{
                btn.bind(DC.E_TAP_DOWN, DC.buttonTapDownHandler)
                .bind(DC.E_TAP_UP, DC.buttonTapEndHandler)
                .bind("tap", { context: this, cost:costIntegral  }, function(event){
                    //判断积分是否足够
                    var context = event.data.context,
                        cost = event.data.cost,
                        wall = window.sdk.integralWall; //积分类型/余额

                    //“乐逗商城”提示购买确认框界面，点击”兑换”按钮
                    DGC.ActionUtil.recordUserAction(DGC.Event.EventId.EVENT_MALL_PURCHASE_ALERT_ACTION,{
                        'user_id': (window.sdk.player ?  window.sdk.player.id : null ) ,
                        'game_id': (window.sdk.game ?  window.sdk.game.id : null ),
                        'product_id': context.orderItem.product.identifier,
                        'selected_type': DGC.Event.Option.BUTTON_FREE_GET
                    });

                    //积分不足
                    if(cost > wall.integral){
                        DGC.ActionUtil.showIntegralView(wall.type, true);
                        if(context.integralAction){
                            setTimeout( $.bindFn(context.destory, context) , 500 );
                        }
                    }else{
                        context.callback(true, true);
                        setTimeout( $.bindFn(context.destory, context) , 500 );
                    }
                });
            }

            //显示积分按钮
            btn.show();

            //显示关闭图标
            closeBtn.bind("tap",{ context: this }, this.closeBtnHanlder);
            closeBtn.show();

            buyBtn.addClass('box-flex-3');
        }else{
            //取消按钮
            cancelBtn.bind(DGC.Common.E_TAP_DOWN,DC.buttonTapDownHandler)
                .bind(DGC.Common.E_TAP_UP, DC.buttonTapEndHandler)
                .bind("tap",{ context: this }, this.closeBtnHanlder);
            cancelBtn.show();

            buyBtn.addClass('box-flex-1');
        }
    },

    /**
     * 关闭窗口
     */
    closeBtnHanlder: function(event){
        var context = event.data.context;
        setTimeout( $.bindFn(context.destory, context) , 500 );
        context.callback(false);

        //“乐逗商城”提示购买确认框界面，点击”取消”
        DGC.ActionUtil.recordUserAction(DGC.Event.EventId.EVENT_MALL_PURCHASE_ALERT_ACTION,{
            'user_id': (window.sdk.player ?  window.sdk.player.id : null ) ,
            'game_id': (window.sdk.game ?  window.sdk.game.id : null ),
            'product_id': context.orderItem.product.identifier,
            'selected_type': DGC.Event.Option.BUTTON_CANCEL
        });
    }
});