/**
 * 存放css是否已经加载
 */
var cssCaches = {};

/**
 * 动态加载CSS文件
 * @param {String || Array} files 单个文件路径或数组(包含文件路径)
 */
var loadCss = function(files) {

    /**
     * 创建css样式外部引用元素
     */
    function createlink(src){
        //判断是否载入过
        if(window.cssCaches[src]){
            return false;
        }

        var head = document.getElementsByTagName("head")[0],
        link = document.createElement("link");
        link.rel = "stylesheet";
        link.href = src;
        head.appendChild(link);

        //标识已经CSS加载
        window.cssCaches[src] = true;
    }

    //支持数组和单个文件两种引用模式
    if(files instanceof Array){
        for(var i = 0; i < files.length ; i++){
            createlink(files[i]);
        }
    }else{
        createlink(files);
    }
};
